#include "configapp.h"
#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "WirelessProtocols/MCHP_API.h"
#include "string.h"
#include "delays.h"
#include "LEDCommands.h"


#define MAX_SEND_FAULT 3

extern BYTE LCDText[16*2+1];
int P2PAddressToIndex(BYTE * RecAddress);
BYTE SendFaultCount[CONNECTION_SIZE];
BYTE FirtSendCheck = 1;
BYTE RSSI0 = 1;
BOOL ActiveMiWiConnection = 0;
extern unsigned int VoltageMeasurement;
extern unsigned int CurrentMeasurement;

void P2PServerTaks(void)
{
	int i = 0;
	if( MiApp_MessageAvailable() )
        {
	        if (rxMessage.PayloadSize >= 3) //A command is three bytes long / discard shorter packets
	        {
		        RSSI0 = rxMessage.PacketRSSI >> 5; //Store the RSSI value for the LCD
		        for(i = 0; (i + 2) < rxMessage.PayloadSize; i++)
	            {
	                //Proccess message in chunks of threee
	                int CommandCode = rxMessage.Payload[i];
					int Param1 = rxMessage.Payload[++i];
					int Param2 = rxMessage.Payload[++i];
					
					
					
					/*These firt two cases (7 & 10) require a response therefore 
					they are processed here*/
					if (CommandCode == CLOSE_COMMAND) //Close connection
					{
						if (Param1 == 17 && Param2 == 27)  //verification bytes
						{
							int iRemove = -1;
							iRemove = P2PAddressToIndex(rxMessage.SourceAddress);
							if (iRemove != -1)
							{
       			        		MiApp_RemoveConnection(iRemove);			
       						}			        	
				        }	            			
                  			
					} 
					else if (CommandCode == REQUEST_LED_TABLE_COMMAND) //Request for LED Table
					{
					
						if (Param1 == 110 && Param2 == 210)  //verification bytes
						{
							int SendLength;
							MiApp_FlushTx();								
							SendLength = BuildLEDTableResponse(TxBuffer);
							TxData += SendLength;
							MiApp_UnicastAddress(rxMessage.SourceAddress, TRUE, FALSE);
							Nop();
							Nop();
							Nop();
							
						}
					}	
					else if (CommandCode == REQUEST_POWER_COMMAND)
						{
							MiApp_FlushTx();
							MiApp_WriteData(REQUEST_POWER_COMMAND); //Response Code
							MiApp_WriteData((BYTE) (VoltageMeasurement >> 8)); //High Byte
							MiApp_WriteData((BYTE) (VoltageMeasurement)); //Low Byte
							MiApp_WriteData((BYTE) (CurrentMeasurement >> 8)); //High Byte
							MiApp_WriteData((BYTE) (CurrentMeasurement)); //Low Byte
							MiApp_UnicastAddress(rxMessage.SourceAddress, TRUE, FALSE);
					}
					else //Send it to the LEDCommands module for processing
					{
						LED_COMMAND command;
						command.commandcode = CommandCode;
						command.param[0] = Param1;
						command.param[1] = Param2;
						ProcessLEDCommand(&command);
						
					}	
	                 
	            }
         	}
         
	         MiApp_DiscardMessage();
	        	
            
           
            

        }
      
    	if (ConnectionTable[0].status.bits.isValid)
    	{
	    	ActiveMiWiConnection = 1;
	    	LCDText[13] = RSSI0; //Display signal strength of the last packet.

	    }	 
	    else
	    {
			ActiveMiWiConnection = 0;
			LCDText[13] = ' ';
			
		}    
}

/*This function is here to clean up dead connections.
  It should be set to tick at some interval */
void P2PServerTick(void)
{
	int i;
	//Initialize the fault count to 0.
	if (FirtSendCheck)
	{
		 for (i=0; i < CONNECTION_SIZE; i++)
		 {
			 SendFaultCount[i] = 0;
		 } 
		 FirtSendCheck = 0;
	}	
	
	//Check P2P Connections
	 for (i=0; i < CONNECTION_SIZE; i++)
	 {
		if (ConnectionTable[i].status.bits.isValid)
		{
			BYTE sendSuccess = 0;
			MiApp_FlushTx();
			MiApp_WriteData(255); //Dummy Data
			sendSuccess = MiApp_UnicastConnection(i, FALSE);
			if (!sendSuccess)
			{
				SendFaultCount[i]++;	
			}
			else
			{
				SendFaultCount[i] = 0;
			}
			if 	(SendFaultCount[i] > MAX_SEND_FAULT)
			{
				MiApp_RemoveConnection(i);
				FirtSendCheck = 1;
				break;
			}		
		}
	 }

}		